[LC优选算法#18] 前缀和 | 除⾃⾝以外数组的乘积 | 和为K的⼦数组 | 和可被K整除的⼦数组

1. 除⾃⾝以外数组的乘积

除⾃⾝以外数组的乘积

解题思路:

由于题目限制了不能使用除法,因此不能采用全部相乘在除以nums[i]的方式解题。从暴力解法出发,我们只能将除nums[i]以外的元素相乘后逐个放入数组,但这样重复的操作太多,不符合O(N)的时间复杂度。因此,我们采用前缀和思想优化暴力解法。

  1. 前缀和 O(N):对于返回数组中的每一个结果ret[i],都是由两部分组成的:前面 元素的乘积 * 后面 元素的乘积。因此,我们可以预处理出两个前缀和数组,一个数组存储每个数之前元素的乘积,另一个存之后元素的乘积。
cpp 复制代码
class Solution {
public:
    vector<int> productExceptSelf(vector<int>& nums)
    {
        int n = nums.size();
        vector<int> fx(n, 1);
        vector<int> gx(n, 1);

        for(int i=1; i<n; i++)
        {
            fx[i] = fx[i - 1] * nums[i - 1];
        }

        for(int i=n-2; i>=0; i--)
        {
            gx[i] = gx[i + 1] * nums[i + 1];
        }

        vector<int> ret;
        for(int i=0; i<n; i++)
        {
            int left = fx[i];
            int right = gx[i];

            ret.push_back(left * right);
        }

        return ret;
    }
};

2. 和为K的⼦数组

和为 k 的⼦数组

解题思路:

  1. 暴力 O(N^2):固定起始位置向后枚举,每次加到末尾,统计数组中和为K的子数组个数。
  2. 前缀和 + 哈希表 时O(N)空O(N):这道题和前缀和的例题类似,但如果只是单单预处理一个前缀和数组,后续还需要进行多次相减才能找到和为K的连续子数组个数,和暴力枚举貌似没区别。对此,我们引入哈希表 存储,这样问题就转化为在数组中查找和为sum[i] - k的前缀和了。
cpp 复制代码
class Solution {
public:
    int subarraySum(vector<int>& nums, int k)
    {
        unordered_map<int, int> hash;
        int sum = 0, cnt = 0;
        hash[0] = 1;
        
        for(auto x : nums)
        {
            sum += x;
            if(hash.count(sum - k) == 1)
            {
                cnt += hash[sum - k];
            }

            hash[sum]++;
        }

        return cnt;
    }
};

3. 和可被K整除的⼦数组

和可被K整除的⼦数组

前置知识:

  • 同余定理 :如果 (a - b) % n == 0,那么我们可以得到一个结论:a % n == b % n,反过来也成立。⽤⽂字叙述就是,如果两个数相减的差能被 n 整除,当且仅当这两个数对 n 取模的结果相同。
  • 负数取模修正 :C++中对负数取模,结果还会返回负数(取模结果加上符号)。我们需要对取模结果进行修正,以(a % n + n) % n的形式输出保证为正。例如:-1 % 3 = (-1 % 3 + 3) % 3 = 2。

解题思路:

  1. 前缀和 + 哈希表 时O(N)空O(N):本题解题思路和上题类似,都是用哈希表+前缀和 解决。根据同余定理,如果s1 % k和sum % k的余数相同,那么所求的子区间(sum - s1) % k == 0。这样问题就变为:找到在[0, i - 1]区间内,有多少前缀和的余数等于sum[i] % k的区间即可。
cpp 复制代码
class Solution {
public:
    int subarraysDivByK(vector<int>& nums, int k)
    {
        unordered_map<int, int> hash; //存储余数+出现次数

        int sum = 0, ret = 0;
        hash[0] = 1; //0位置初始化为1,因为0是可以整除任何数的元素

        for(auto x : nums)
        {
            sum += x;
            int r = (sum % k + k) % k;
            if(hash.count(r))
            {
                ret += hash[r]; //sum范围内所有余数为r的子区间都满足
            }

            hash[r]++;
        }

        return ret;
    }
};

// 本期内容就到这里啦,如果对你有帮助,请三连支持!我是青云,我们下期见^_~

相关推荐
专注仿真2 小时前
ACM算法
算法·深度优先
顺顺 尼5 小时前
linux 进程信号(上)
linux·c++·算法
罗西的思考5 小时前
[Agent Memory / 强化学习] MemPO源码学习笔记 ---(5)--- GRPO
人工智能·算法·机器学习
richard_yuu5 小时前
动态规划:强化学习的「数学基础」,从 MDP 到值迭代
深度学习·神经网络·算法·yolo·机器学习·动态规划
mmmmath_35 小时前
LeetCode.225.用队列实现栈
算法
Elaine3365 小时前
数据结构与算法-程序
数据结构·python·算法·计算机基础·编程基础
2601_965742225 小时前
布局GEO AI本地营销,我重点看这几个细节
大数据·人工智能·算法·ai·新媒体运营
EatFan5 小时前
AI Agent 上生产前先加三道闸门:审批、限权、可回放的工程实践
人工智能·python·算法·多智能体·ai agent·mcp·harness
思茂信息6 小时前
CST软件BCI仿真模型及仿真案例
开发语言·单片机·嵌入式硬件·算法·emc
Persistent的粽子!6 小时前
双指针算法:最大盛水容器
c++·算法·leetcode